<template>
    <div class="ss">
        <v-card-title class="pb-1 pt-3 mb-0">选择项目：</v-card-title>
        <v-select
            solo
            dark
            :items="projects"
            background-color="#5555d0"
            item-text="projectName"
            item-value="projectName"
            v-model="selectedProject"
            @change="changeSP"
        ></v-select>
    </div>
</template>

<script>
export default {
    name: "selectProject",
    data: () => ({
        projects: [],
        user: "",
        selectedProject: "",
    }),
    methods: {
        changeSP() {
            console.log(this.selectedProject);

            this.$store.dispatch("setProjectName", this.selectedProject);
            this.$evtbus.$emit("projectchange");
        },
        loadProjects(callback) {
            console.log("show projects: -----------", this.user);
            this.$axios({
                method: "post",
                url: `/showprojects`,
                data: {
                    userName: this.user,
                },
            }).then(res => {
                if (res.status === 200) {
                    const data = res.data;
                    console.log(200);
                    console.log(data);
                    if (data.status === "SUCCESS") {
                        this.projects = data.projects;

                        callback && callback();
                    } else {
                        alert("出错了！");
                    }
                } else {
                    alert("连接失败。\n请检查您的网络状态。");
                }
            });
        },
    },
    mounted() {
        this.$evtbus.$on("CodeEdit.ProjectNameInit", projectName => {
            this.selectedProject = projectName;
            this.changeSP();
        });

        // 项目删除后，要清除selectProject逻辑
        this.$evtbus.$on("CodeEdit.ProjectRemoved", data => {
            // console.log("selectProject:  project Remove", data, this.selectedProject);
            if (data.projectName === this.selectedProject) {
                this.loadProjects(() => {
                    // console.log(this.selectedProject);
                    this.selectedProject = "";
                    this.changeSP();
                });
            }

            return;
        });

        // 项目用户删除后，也要清除selectProject逻辑
        this.$evtbus.$on("CodeEdit.ProjectUserRemoved", data => {
            if (data.projectName === this.selectedProject) {
                this.loadProjects(() => {
                    // console.log(this.selectedProject);
                    this.selectedProject = "";
                    this.changeSP();
                });
            }

            return;
        });

        this.user = this.$store.getters.userName;
        // this.selectedProject = this.$store.getters.projectName;
        this.loadProjects();
    },
};
</script>

<style scoped>
.ss {
    padding-left: 60px;
    padding-top: 60px;
}
</style>
